#ifndef _AT91SAM7S128_H_
#define _AT91SAM7S128_H_

//-----------------------------------------------

//-- Advanced Interrupt Controller --

#define AIC_BASE 0xFFFFF000

#define  rAIC_SMR0   (*(volatile unsigned long *)0xFFFFF000)
#define  rAIC_SMR1   (*(volatile unsigned long *)0xFFFFF004)
#define  rAIC_SMR2   (*(volatile unsigned long *)0xFFFFF008)
#define  rAIC_SMR3   (*(volatile unsigned long *)0xFFFFF00C)
#define  rAIC_SMR4   (*(volatile unsigned long *)0xFFFFF010)
#define  rAIC_SMR5   (*(volatile unsigned long *)0xFFFFF014)
#define  rAIC_SMR6   (*(volatile unsigned long *)0xFFFFF018)
#define  rAIC_SMR7   (*(volatile unsigned long *)0xFFFFF01C)
#define  rAIC_SMR8   (*(volatile unsigned long *)0xFFFFF020)
#define  rAIC_SMR9   (*(volatile unsigned long *)0xFFFFF024)
#define  rAIC_SMR10  (*(volatile unsigned long *)0xFFFFF028)
#define  rAIC_SMR11  (*(volatile unsigned long *)0xFFFFF02C)
#define  rAIC_SMR12  (*(volatile unsigned long *)0xFFFFF030)
#define  rAIC_SMR13  (*(volatile unsigned long *)0xFFFFF034)
#define  rAIC_SMR14  (*(volatile unsigned long *)0xFFFFF038)
#define  rAIC_SMR15  (*(volatile unsigned long *)0xFFFFF03C)
#define  rAIC_SMR16  (*(volatile unsigned long *)0xFFFFF040)
#define  rAIC_SMR17  (*(volatile unsigned long *)0xFFFFF044)
#define  rAIC_SMR18  (*(volatile unsigned long *)0xFFFFF048)
#define  rAIC_SMR19  (*(volatile unsigned long *)0xFFFFF04C)
#define  rAIC_SMR20  (*(volatile unsigned long *)0xFFFFF050)
#define  rAIC_SMR21  (*(volatile unsigned long *)0xFFFFF054)
#define  rAIC_SMR22  (*(volatile unsigned long *)0xFFFFF058)
#define  rAIC_SMR23  (*(volatile unsigned long *)0xFFFFF05C)
#define  rAIC_SMR24  (*(volatile unsigned long *)0xFFFFF060)
#define  rAIC_SMR25  (*(volatile unsigned long *)0xFFFFF064)
#define  rAIC_SMR26  (*(volatile unsigned long *)0xFFFFF068)
#define  rAIC_SMR27  (*(volatile unsigned long *)0xFFFFF06C)
#define  rAIC_SMR28  (*(volatile unsigned long *)0xFFFFF070)
#define  rAIC_SMR29  (*(volatile unsigned long *)0xFFFFF074)
#define  rAIC_SMR30  (*(volatile unsigned long *)0xFFFFF078)
#define  rAIC_SMR31  (*(volatile unsigned long *)0xFFFFF07C)

#define  rAIC_SVR0   (*(volatile unsigned long *)0xFFFFF080)
#define  rAIC_SVR1   (*(volatile unsigned long *)0xFFFFF084)
#define  rAIC_SVR2   (*(volatile unsigned long *)0xFFFFF088)
#define  rAIC_SVR3   (*(volatile unsigned long *)0xFFFFF08C)
#define  rAIC_SVR4   (*(volatile unsigned long *)0xFFFFF090)
#define  rAIC_SVR5   (*(volatile unsigned long *)0xFFFFF094)
#define  rAIC_SVR6   (*(volatile unsigned long *)0xFFFFF098)
#define  rAIC_SVR7   (*(volatile unsigned long *)0xFFFFF09C)
#define  rAIC_SVR8   (*(volatile unsigned long *)0xFFFFF0A0)
#define  rAIC_SVR9   (*(volatile unsigned long *)0xFFFFF0A4)
#define  rAIC_SVR10  (*(volatile unsigned long *)0xFFFFF0A8)
#define  rAIC_SVR11  (*(volatile unsigned long *)0xFFFFF0AC)
#define  rAIC_SVR12  (*(volatile unsigned long *)0xFFFFF0B0)
#define  rAIC_SVR13  (*(volatile unsigned long *)0xFFFFF0B4)
#define  rAIC_SVR14  (*(volatile unsigned long *)0xFFFFF0B8)
#define  rAIC_SVR15  (*(volatile unsigned long *)0xFFFFF0BC)
#define  rAIC_SVR16  (*(volatile unsigned long *)0xFFFFF0C0)
#define  rAIC_SVR17  (*(volatile unsigned long *)0xFFFFF0C4)
#define  rAIC_SVR18  (*(volatile unsigned long *)0xFFFFF0C8)
#define  rAIC_SVR19  (*(volatile unsigned long *)0xFFFFF0CC)
#define  rAIC_SVR20  (*(volatile unsigned long *)0xFFFFF0D0)
#define  rAIC_SVR21  (*(volatile unsigned long *)0xFFFFF0D4)
#define  rAIC_SVR22  (*(volatile unsigned long *)0xFFFFF0D8)
#define  rAIC_SVR23  (*(volatile unsigned long *)0xFFFFF0DC)
#define  rAIC_SVR24  (*(volatile unsigned long *)0xFFFFF0E0)
#define  rAIC_SVR25  (*(volatile unsigned long *)0xFFFFF0E4)
#define  rAIC_SVR26  (*(volatile unsigned long *)0xFFFFF0E8)
#define  rAIC_SVR27  (*(volatile unsigned long *)0xFFFFF0EC)
#define  rAIC_SVR28  (*(volatile unsigned long *)0xFFFFF0F0)
#define  rAIC_SVR29  (*(volatile unsigned long *)0xFFFFF0F4)
#define  rAIC_SVR30  (*(volatile unsigned long *)0xFFFFF0F8)
#define  rAIC_SVR31  (*(volatile unsigned long *)0xFFFFF0FC)

#define  rAIC_IVR    (*(volatile unsigned long *)0xFFFFF100)
#define  rAIC_FVR    (*(volatile unsigned long *)0xFFFFF104)
#define  rAIC_ISR    (*(volatile unsigned long *)0xFFFFF108)
#define  rAIC_IPR    (*(volatile unsigned long *)0xFFFFF10C)
#define  rAIC_IMR    (*(volatile unsigned long *)0xFFFFF110)
#define  rAIC_CISR   (*(volatile unsigned long *)0xFFFFF114)
#define  rAIC_IECR   (*(volatile unsigned long *)0xFFFFF120)
#define  rAIC_IDCR   (*(volatile unsigned long *)0xFFFFF124)
#define  rAIC_ICCR   (*(volatile unsigned long *)0xFFFFF128)
#define  rAIC_ISCR   (*(volatile unsigned long *)0xFFFFF12C)
#define  rAIC_EOICR  (*(volatile unsigned long *)0xFFFFF130)
#define  rAIC_SPU    (*(volatile unsigned long *)0xFFFFF134)
#define  rAIC_DCR    (*(volatile unsigned long *)0xFFFFF138)
#define  rAIC_FFER   (*(volatile unsigned long *)0xFFFFF140)
#define  rAIC_FFDR   (*(volatile unsigned long *)0xFFFFF144)
#define  rAIC_FFSR   (*(volatile unsigned long *)0xFFFFF148)

//-- Debug Unit --

#define DBGU_BASE 0xFFFFF200

#define  rDBGU_CR    (*(volatile unsigned long *)0xFFFFF200)
#define  rDBGU_MR    (*(volatile unsigned long *)0xFFFFF204)
#define  rDBGU_IER   (*(volatile unsigned long *)0xFFFFF208)
#define  rDBGU_IDR   (*(volatile unsigned long *)0xFFFFF20C)
#define  rDBGU_IMR   (*(volatile unsigned long *)0xFFFFF210)
#define  rDBGU_SR    (*(volatile unsigned long *)0xFFFFF214)
#define  rDBGU_RHR   (*(volatile unsigned long *)0xFFFFF218)
#define  rDBGU_THR   (*(volatile unsigned long *)0xFFFFF21C)
#define  rDBGU_BRGR  (*(volatile unsigned long *)0xFFFFF220)
#define  rDBGU_CIDR  (*(volatile unsigned long *)0xFFFFF240)
#define  rDBGU_EXID  (*(volatile unsigned long *)0xFFFFF244)
#define  rDBGU_FNR   (*(volatile unsigned long *)0xFFFFF248)
#define  rDBGU_RPR   (*(volatile unsigned long *)0xFFFFF300)
#define  rDBGU_RCR   (*(volatile unsigned long *)0xFFFFF304)
#define  rDBGU_TPR   (*(volatile unsigned long *)0xFFFFF308)
#define  rDBGU_TCR   (*(volatile unsigned long *)0xFFFFF30C)
#define  rDBGU_RNPR  (*(volatile unsigned long *)0xFFFFF310)
#define  rDBGU_RNCR  (*(volatile unsigned long *)0xFFFFF314)
#define  rDBGU_TNPR  (*(volatile unsigned long *)0xFFFFF318)
#define  rDBGU_TNCR  (*(volatile unsigned long *)0xFFFFF31C)
#define  rDBGU_PTCR  (*(volatile unsigned long *)0xFFFFF320)
#define  rDBGU_PTSR  (*(volatile unsigned long *)0xFFFFF324)


//-- PIO Controller A --

#define PIO_BASE 0xFFFFF400

#define  rPIO_PER    (*(volatile unsigned long *)0xFFFFF400)
#define  rPIO_PDR    (*(volatile unsigned long *)0xFFFFF404)
#define  rPIO_PSR    (*(volatile unsigned long *)0xFFFFF408)
#define  rPIO_OER    (*(volatile unsigned long *)0xFFFFF410)
#define  rPIO_ODR    (*(volatile unsigned long *)0xFFFFF414)
#define  rPIO_OSR    (*(volatile unsigned long *)0xFFFFF418)
#define  rPIO_IFER   (*(volatile unsigned long *)0xFFFFF420)
#define  rPIO_IFDR   (*(volatile unsigned long *)0xFFFFF424)
#define  rPIO_IFSR   (*(volatile unsigned long *)0xFFFFF428)
#define  rPIO_SODR   (*(volatile unsigned long *)0xFFFFF430)
#define  rPIO_CODR   (*(volatile unsigned long *)0xFFFFF434)
#define  rPIO_ODSR   (*(volatile unsigned long *)0xFFFFF438)
#define  rPIO_PDSR   (*(volatile unsigned long *)0xFFFFF43C)
#define  rPIO_IER    (*(volatile unsigned long *)0xFFFFF440)
#define  rPIO_IDR    (*(volatile unsigned long *)0xFFFFF444)
#define  rPIO_IMR    (*(volatile unsigned long *)0xFFFFF448)
#define  rPIO_ISR    (*(volatile unsigned long *)0xFFFFF44C)
#define  rPIO_MDER   (*(volatile unsigned long *)0xFFFFF450)
#define  rPIO_MDDR   (*(volatile unsigned long *)0xFFFFF454)
#define  rPIO_MDSR   (*(volatile unsigned long *)0xFFFFF458)
#define  rPIO_PUDR   (*(volatile unsigned long *)0xFFFFF460)
#define  rPIO_PUER   (*(volatile unsigned long *)0xFFFFF464)
#define  rPIO_PUSR   (*(volatile unsigned long *)0xFFFFF468)
#define  rPIO_ASR    (*(volatile unsigned long *)0xFFFFF470)
#define  rPIO_BSR    (*(volatile unsigned long *)0xFFFFF474)
#define  rPIO_ABSR   (*(volatile unsigned long *)0xFFFFF478)
#define  rPIO_OWER   (*(volatile unsigned long *)0xFFFFF4A0)
#define  rPIO_OWDR   (*(volatile unsigned long *)0xFFFFF4A4)
#define  rPIO_OWSR   (*(volatile unsigned long *)0xFFFFF4A8)

//-- Power Management Controller --

#define PMC_BASE 0xFFFFFC00

#define  rPMC_SCER   (*(volatile unsigned long *)0xFFFFFC00)
#define  rPMC_SCDR   (*(volatile unsigned long *)0xFFFFFC04)
#define  rPMC_SCSR   (*(volatile unsigned long *)0xFFFFFC08)
#define  rPMC_PCER   (*(volatile unsigned long *)0xFFFFFC10)
#define  rPMC_PCDR   (*(volatile unsigned long *)0xFFFFFC14)
#define  rPMC_PCSR   (*(volatile unsigned long *)0xFFFFFC18)
#define  rCKGR_MOR   (*(volatile unsigned long *)0xFFFFFC20)
#define  rCKGR_MCFR  (*(volatile unsigned long *)0xFFFFFC24)
#define  rCKGR_PLLR  (*(volatile unsigned long *)0xFFFFFC2C)
#define  rPMC_MCKR   (*(volatile unsigned long *)0xFFFFFC30)
#define  rPMC_PCK0   (*(volatile unsigned long *)0xFFFFFC40)
#define  rPMC_PCK1   (*(volatile unsigned long *)0xFFFFFC44)
#define  rPMC_IER    (*(volatile unsigned long *)0xFFFFFC60)
#define  rPMC_IDR    (*(volatile unsigned long *)0xFFFFFC64)
#define  rPMC_SR     (*(volatile unsigned long *)0xFFFFFC68)
#define  rPMC_IMR    (*(volatile unsigned long *)0xFFFFFC6C)

//-- Reset Controller --

#define RSTC_BASE 0xFFFFFD00

#define  rRSTC_CR    (*(volatile unsigned long *)0xFFFFFD00)
#define  rRSTC_SR    (*(volatile unsigned long *)0xFFFFFD04)
#define  rRSTC_MR    (*(volatile unsigned long *)0xFFFFFD08)

//-- Real-time Timer --

#define RTT_BASE 0xFFFFFD20

#define  rRTT_MR     (*(volatile unsigned long *)0xFFFFFD20)
#define  rRTT_AR     (*(volatile unsigned long *)0xFFFFFD24)
#define  rRTT_VR     (*(volatile unsigned long *)0xFFFFFD28)
#define  rRTT_SR     (*(volatile unsigned long *)0xFFFFFD2C)

//-- Periodic Interval Timer --

#define PIT_BASE 0xFFFFFD30

#define  rPIT_MR     (*(volatile unsigned long *)0xFFFFFD30)
#define  rPIT_SR     (*(volatile unsigned long *)0xFFFFFD34)
#define  rPIT_PIVR   (*(volatile unsigned long *)0xFFFFFD38)
#define  rPIT_PIIR   (*(volatile unsigned long *)0xFFFFFD3C)

//--  Watchdog Timer --

#define WDT_BASE 0xFFFFFD40

#define  rWDT_CR     (*(volatile unsigned long *)0xFFFFFD40)
#define  rWDT_MR     (*(volatile unsigned long *)0xFFFFFD44)
#define  rWDT_SR     (*(volatile unsigned long *)0xFFFFFD48)

//-- Voltage Regulator Mode Controller --

#define VREG_BASE 0xFFFFFD60

#define  rVREG_MR    (*(volatile unsigned long *)0xFFFFFD60)

//-- Memory Controller --

#define MC_BASE 0xFFFFFF00

#define  rMC_RCR     (*(volatile unsigned long *)0xFFFFFF00)
#define  rMC_ASR     (*(volatile unsigned long *)0xFFFFFF04)
#define  rMC_AASR    (*(volatile unsigned long *)0xFFFFFF08)

#define  rMC_FMR     (*(volatile unsigned long *)0xFFFFFF60)
#define  rMC_FCR     (*(volatile unsigned long *)0xFFFFFF64)
#define  rMC_FSR     (*(volatile unsigned long *)0xFFFFFF68)

     //----------------- Peripherals ------------------------

//--- Timer/Counter 0,1,2

#define TC012_BASE 0xFFFA0000

#define  rTC0_CCR    (*(volatile unsigned long *)0xFFFA0000)
#define  rTC0_CMR    (*(volatile unsigned long *)0xFFFA0004)
#define  rTC0_CV     (*(volatile unsigned long *)0xFFFA0010)
#define  rTC0_RA     (*(volatile unsigned long *)0xFFFA0014)
#define  rTC0_RB     (*(volatile unsigned long *)0xFFFA0018)
#define  rTC0_RC     (*(volatile unsigned long *)0xFFFA001C)
#define  rTC0_SR     (*(volatile unsigned long *)0xFFFA0020)
#define  rTC0_IER    (*(volatile unsigned long *)0xFFFA0024)
#define  rTC0_IDR    (*(volatile unsigned long *)0xFFFA0028)
#define  rTC0_IMR    (*(volatile unsigned long *)0xFFFA002C)

#define  rTC1_CCR    (*(volatile unsigned long *)0xFFFA0040)
#define  rTC1_CMR    (*(volatile unsigned long *)0xFFFA0044)
#define  rTC1_CV     (*(volatile unsigned long *)0xFFFA0050)
#define  rTC1_RA     (*(volatile unsigned long *)0xFFFA0054)
#define  rTC1_RB     (*(volatile unsigned long *)0xFFFA0058)
#define  rTC1_RC     (*(volatile unsigned long *)0xFFFA005C)
#define  rTC1_SR     (*(volatile unsigned long *)0xFFFA0060)
#define  rTC1_IER    (*(volatile unsigned long *)0xFFFA0064)
#define  rTC1_IDR    (*(volatile unsigned long *)0xFFFA0068)
#define  rTC1_IMR    (*(volatile unsigned long *)0xFFFA006C)

#define  rTC2_CCR    (*(volatile unsigned long *)0xFFFA0080)
#define  rTC2_CMR    (*(volatile unsigned long *)0xFFFA0084)
#define  rTC2_CV     (*(volatile unsigned long *)0xFFFA0090)
#define  rTC2_RA     (*(volatile unsigned long *)0xFFFA0094)
#define  rTC2_RB     (*(volatile unsigned long *)0xFFFA0098)
#define  rTC2_RC     (*(volatile unsigned long *)0xFFFA009C)
#define  rTC2_SR     (*(volatile unsigned long *)0xFFFA00A0)
#define  rTC2_IER    (*(volatile unsigned long *)0xFFFA00A4)
#define  rTC2_IDR    (*(volatile unsigned long *)0xFFFA00A8)
#define  rTC2_IMR    (*(volatile unsigned long *)0xFFFA00AC)

#define  rTC_BCR     (*(volatile unsigned long *)0xFFFA00C0)
#define  rTC_BMR     (*(volatile unsigned long *)0xFFFA00C4)

//-- USB Device Port --

#define UDP_BASE  0xFFFB0000

#define  rUDP_FRM_NUM  (*(volatile unsigned long *)0xFFFB0000)
#define  rUDP_GLB_STAT (*(volatile unsigned long *)0xFFFB0004)
#define  rUDP_FADDR    (*(volatile unsigned long *)0xFFFB0008)
#define  rUDP_IER      (*(volatile unsigned long *)0xFFFB0010)
#define  rUDP_IDR      (*(volatile unsigned long *)0xFFFB0014)
#define  rUDP_IMR      (*(volatile unsigned long *)0xFFFB0018)
#define  rUDP_ISR      (*(volatile unsigned long *)0xFFFB001C)
#define  rUDP_ICR      (*(volatile unsigned long *)0xFFFB0020)
#define  rUDP_RST_EP   (*(volatile unsigned long *)0xFFFB0028)
#define  rUDP_CSR0     (*(volatile unsigned long *)0xFFFB0030)
#define  rUDP_CSR1     (*(volatile unsigned long *)0xFFFB0034)
#define  rUDP_CSR2     (*(volatile unsigned long *)0xFFFB0038)
#define  rUDP_CSR3     (*(volatile unsigned long *)0xFFFB003C)
#define  rUDP_FDR0     (*(volatile unsigned long *)0xFFFB0050)
#define  rUDP_FDR1     (*(volatile unsigned long *)0xFFFB0054)
#define  rUDP_FDR2     (*(volatile unsigned long *)0xFFFB0058)
#define  rUDP_FDR3     (*(volatile unsigned long *)0xFFFB005C)
#define  rUDP_TXVC     (*(volatile unsigned long *)0xFFFB0074)

//-- Two-Wire Interface --

#define TWI_BASE 0xFFFB8000

#define  rTWI_CR       (*(volatile unsigned long *)0xFFFB8000)
#define  rTWI_MMR      (*(volatile unsigned long *)0xFFFB8004)
#define  rTWI_IADR     (*(volatile unsigned long *)0xFFFB800C)
#define  rTWI_CWGR     (*(volatile unsigned long *)0xFFFB8010)
#define  rTWI_SR       (*(volatile unsigned long *)0xFFFB8020)
#define  rTWI_IER      (*(volatile unsigned long *)0xFFFB8024)
#define  rTWI_IDR      (*(volatile unsigned long *)0xFFFB8028)
#define  rTWI_IMR      (*(volatile unsigned long *)0xFFFB802C)
#define  rTWI_RHR      (*(volatile unsigned long *)0xFFFB8030)
#define  rTWI_THR      (*(volatile unsigned long *)0xFFFB8034)

//-- USART 0 --

#define USART0_BASE  0xFFFC0000

#define  rUS0_CR       (*(volatile unsigned long *)0xFFFC0000)
#define  rUS0_MR       (*(volatile unsigned long *)0xFFFC0004)
#define  rUS0_IER      (*(volatile unsigned long *)0xFFFC0008)
#define  rUS0_IDR      (*(volatile unsigned long *)0xFFFC000C)
#define  rUS0_IMR      (*(volatile unsigned long *)0xFFFC0010)
#define  rUS0_CSR      (*(volatile unsigned long *)0xFFFC0014)
#define  rUS0_RHR      (*(volatile unsigned long *)0xFFFC0018)
#define  rUS0_THR      (*(volatile unsigned long *)0xFFFC001C)
#define  rUS0_BRGR     (*(volatile unsigned long *)0xFFFC0020)
#define  rUS0_RTOR     (*(volatile unsigned long *)0xFFFC0024)
#define  rUS0_TTGR     (*(volatile unsigned long *)0xFFFC0028)
#define  rUS0_FIDI     (*(volatile unsigned long *)0xFFFC0040)
#define  rUS0_NER      (*(volatile unsigned long *)0xFFFC0044)
#define  rUS0_IF       (*(volatile unsigned long *)0xFFFC004C)

#define  rUS0_MAN      (*(volatile unsigned long *)0xFFFC0050)

#define  rUS0_RPR      (*(volatile unsigned long *)0xFFFC0100)
#define  rUS0_RCR      (*(volatile unsigned long *)0xFFFC0104)
#define  rUS0_TPR      (*(volatile unsigned long *)0xFFFC0108)
#define  rUS0_TCR      (*(volatile unsigned long *)0xFFFC010C)
#define  rUS0_RNPR     (*(volatile unsigned long *)0xFFFC0110)
#define  rUS0_RNCR     (*(volatile unsigned long *)0xFFFC0114)
#define  rUS0_TNPR     (*(volatile unsigned long *)0xFFFC0118)
#define  rUS0_TNCR     (*(volatile unsigned long *)0xFFFC011C)
#define  rUS0_PTCR     (*(volatile unsigned long *)0xFFFC0120)
#define  rUS0_PTSR     (*(volatile unsigned long *)0xFFFC0124)

//-- USART 1 --

#define USART1_BASE 0xFFFC4000

#define  rUS1_CR       (*(volatile unsigned long *)0xFFFC4000)
#define  rUS1_MR       (*(volatile unsigned long *)0xFFFC4004)
#define  rUS1_IER      (*(volatile unsigned long *)0xFFFC4008)
#define  rUS1_IDR      (*(volatile unsigned long *)0xFFFC400C)
#define  rUS1_IMR      (*(volatile unsigned long *)0xFFFC4010)
#define  rUS1_CSR      (*(volatile unsigned long *)0xFFFC4014)
#define  rUS1_RHR      (*(volatile unsigned long *)0xFFFC4018)
#define  rUS1_THR      (*(volatile unsigned long *)0xFFFC401C)
#define  rUS1_BRGR     (*(volatile unsigned long *)0xFFFC4020)
#define  rUS1_RTOR     (*(volatile unsigned long *)0xFFFC4024)
#define  rUS1_TTGR     (*(volatile unsigned long *)0xFFFC4028)
#define  rUS1_FIDI     (*(volatile unsigned long *)0xFFFC4040)
#define  rUS1_NER      (*(volatile unsigned long *)0xFFFC4044)
#define  rUS1_IF       (*(volatile unsigned long *)0xFFFC404C)

#define  rUS1_MAN      (*(volatile unsigned long *)0xFFFC4050)

#define  rUS1_RPR      (*(volatile unsigned long *)0xFFFC4100)
#define  rUS1_RCR      (*(volatile unsigned long *)0xFFFC4104)
#define  rUS1_TPR      (*(volatile unsigned long *)0xFFFC4108)
#define  rUS1_TCR      (*(volatile unsigned long *)0xFFFC410C)
#define  rUS1_RNPR     (*(volatile unsigned long *)0xFFFC4110)
#define  rUS1_RNCR     (*(volatile unsigned long *)0xFFFC4114)
#define  rUS1_TNPR     (*(volatile unsigned long *)0xFFFC4118)
#define  rUS1_TNCR     (*(volatile unsigned long *)0xFFFC411C)
#define  rUS1_PTCR     (*(volatile unsigned long *)0xFFFC4120)
#define  rUS1_PTSR     (*(volatile unsigned long *)0xFFFC4124)

//-- PWM Controller --

#define PWM_BASE  0xFFFCC000

#define  rPWM_MR      (*(volatile unsigned long *)0xFFFCC000)
#define  rPWM_ENA     (*(volatile unsigned long *)0xFFFCC004)
#define  rPWM_DIS     (*(volatile unsigned long *)0xFFFCC008)
#define  rPWM_SR      (*(volatile unsigned long *)0xFFFCC00C)
#define  rPWM_IER     (*(volatile unsigned long *)0xFFFCC010)
#define  rPWM_IDR     (*(volatile unsigned long *)0xFFFCC014)
#define  rPWM_IMR     (*(volatile unsigned long *)0xFFFCC018)
#define  rPWM_ISR     (*(volatile unsigned long *)0xFFFCC01C)
#define  rPWM_VERSION (*(volatile unsigned long *)0xFFFCC0FC)
#define  rPWM_CMR0    (*(volatile unsigned long *)0xFFFCC200)
#define  rPWM_CDTY0   (*(volatile unsigned long *)0xFFFCC204)
#define  rPWM_CPRD0   (*(volatile unsigned long *)0xFFFCC208)
#define  rPWM_CCNT0   (*(volatile unsigned long *)0xFFFCC20C)
#define  rPWM_CUPD0   (*(volatile unsigned long *)0xFFFCC210)
#define  rPWM_CMR1    (*(volatile unsigned long *)0xFFFCC220)
#define  rPWM_CDTY1   (*(volatile unsigned long *)0xFFFCC224)
#define  rPWM_CPRD1   (*(volatile unsigned long *)0xFFFCC228)
#define  rPWM_CCNT1   (*(volatile unsigned long *)0xFFFCC22C)
#define  rPWM_CUPD1   (*(volatile unsigned long *)0xFFFCC230)

//-- Serial Synchronous Controller --

#define SSC_BASE 0xFFFD4000

#define  rSSC_CR      (*(volatile unsigned long *)0xFFFD4000)
#define  rSSC_CMR     (*(volatile unsigned long *)0xFFFD4004)
#define  rSSC_RCMR    (*(volatile unsigned long *)0xFFFD4010)
#define  rSSC_RFMR    (*(volatile unsigned long *)0xFFFD4014)
#define  rSSC_TCMR    (*(volatile unsigned long *)0xFFFD4018)
#define  rSSC_TFMR    (*(volatile unsigned long *)0xFFFD401C)
#define  rSSC_RHR     (*(volatile unsigned long *)0xFFFD4020)
#define  rSSC_THR     (*(volatile unsigned long *)0xFFFD4024)
#define  rSSC_RSHR    (*(volatile unsigned long *)0xFFFD4030)
#define  rSSC_TSHR    (*(volatile unsigned long *)0xFFFD4034)
#define  rSSC_SR      (*(volatile unsigned long *)0xFFFD4040)
#define  rSSC_IER     (*(volatile unsigned long *)0xFFFD4044)
#define  rSSC_IDR     (*(volatile unsigned long *)0xFFFD4048)
#define  rSSC_IMR     (*(volatile unsigned long *)0xFFFD404C)

#define  rSSC_RPR     (*(volatile unsigned long *)0xFFFD4100)
#define  rSSC_RCR     (*(volatile unsigned long *)0xFFFD4104)
#define  rSSC_TPR     (*(volatile unsigned long *)0xFFFD4108)
#define  rSSC_TCR     (*(volatile unsigned long *)0xFFFD410C)
#define  rSSC_RNPR    (*(volatile unsigned long *)0xFFFD4110)
#define  rSSC_RNCR    (*(volatile unsigned long *)0xFFFD4114)
#define  rSSC_TNPR    (*(volatile unsigned long *)0xFFFD4118)
#define  rSSC_TNCR    (*(volatile unsigned long *)0xFFFD411C)
#define  rSSC_PTCR    (*(volatile unsigned long *)0xFFFD4120)
#define  rSSC_PTSR    (*(volatile unsigned long *)0xFFFD4124)

//-- Analog-to-Digital Converter --

#define ADC_BASE  0xFFFD8000

#define  rADC_CR      (*(volatile unsigned long *)0xFFFD8000)
#define  rADC_MR      (*(volatile unsigned long *)0xFFFD8004)
#define  rADC_CHER    (*(volatile unsigned long *)0xFFFD8010)
#define  rADC_CHDR    (*(volatile unsigned long *)0xFFFD8014)
#define  rADC_CHSR    (*(volatile unsigned long *)0xFFFD8018)
#define  rADC_SR      (*(volatile unsigned long *)0xFFFD801C)
#define  rADC_LCDR    (*(volatile unsigned long *)0xFFFD8020)
#define  rADC_IER     (*(volatile unsigned long *)0xFFFD8024)
#define  rADC_IDR     (*(volatile unsigned long *)0xFFFD8028)
#define  rADC_IMR     (*(volatile unsigned long *)0xFFFD802C)
#define  rADC_CDR0    (*(volatile unsigned long *)0xFFFD8030)
#define  rADC_CDR1    (*(volatile unsigned long *)0xFFFD8034)
#define  rADC_CDR2    (*(volatile unsigned long *)0xFFFD8038)
#define  rADC_CDR3    (*(volatile unsigned long *)0xFFFD803C)
#define  rADC_CDR4    (*(volatile unsigned long *)0xFFFD8040)
#define  rADC_CDR5    (*(volatile unsigned long *)0xFFFD8044)
#define  rADC_CDR6    (*(volatile unsigned long *)0xFFFD8048)
#define  rADC_CDR7    (*(volatile unsigned long *)0xFFFD804C)

#define  rADC_RPR     (*(volatile unsigned long *)0xFFFD8100)
#define  rADC_RCR     (*(volatile unsigned long *)0xFFFD8104)
#define  rADC_TPR     (*(volatile unsigned long *)0xFFFD8108)
#define  rADC_TCR     (*(volatile unsigned long *)0xFFFD810C)
#define  rADC_RNPR    (*(volatile unsigned long *)0xFFFD8110)
#define  rADC_RNCR    (*(volatile unsigned long *)0xFFFD8114)
#define  rADC_TNPR    (*(volatile unsigned long *)0xFFFD8118)
#define  rADC_TNCR    (*(volatile unsigned long *)0xFFFD811C)
#define  rADC_PTCR    (*(volatile unsigned long *)0xFFFD8120)
#define  rADC_PTSR    (*(volatile unsigned long *)0xFFFD8124)

//-- Serial Peripheral Interface --

#define SPI_BASE  0xFFFE0000

#define  rSPI_CR      (*(volatile unsigned long *)0xFFFE0000)
#define  rSPI_MR      (*(volatile unsigned long *)0xFFFE0004)
#define  rSPI_RDR     (*(volatile unsigned long *)0xFFFE0008)
#define  rSPI_TDR     (*(volatile unsigned long *)0xFFFE000C)
#define  rSPI_SR      (*(volatile unsigned long *)0xFFFE0010)
#define  rSPI_IER     (*(volatile unsigned long *)0xFFFE0014)
#define  rSPI_IDR     (*(volatile unsigned long *)0xFFFE0018)
#define  rSPI_IMR     (*(volatile unsigned long *)0xFFFE001C)
#define  rSPI_CSR0    (*(volatile unsigned long *)0xFFFE0030)
#define  rSPI_CSR1    (*(volatile unsigned long *)0xFFFE0034)
#define  rSPI_CSR2    (*(volatile unsigned long *)0xFFFE0038)
#define  rSPI_CSR3    (*(volatile unsigned long *)0xFFFE003C)

#define  rSPI_RPR     (*(volatile unsigned long *)0xFFFE0100)
#define  rSPI_RCR     (*(volatile unsigned long *)0xFFFE0104)
#define  rSPI_TPR     (*(volatile unsigned long *)0xFFFE0108)
#define  rSPI_TCR     (*(volatile unsigned long *)0xFFFE010C)
#define  rSPI_RNPR    (*(volatile unsigned long *)0xFFFE0110)
#define  rSPI_RNCR    (*(volatile unsigned long *)0xFFFE0114)
#define  rSPI_TNPR    (*(volatile unsigned long *)0xFFFE0118)
#define  rSPI_TNCR    (*(volatile unsigned long *)0xFFFE011C)
#define  rSPI_PTCR    (*(volatile unsigned long *)0xFFFE0120)
#define  rSPI_PTSR    (*(volatile unsigned long *)0xFFFE0124)

//-- DMA registers offset

#define  PERIPH_RPR   0x100 //-- Receive Pointer Register       R/W
#define  PERIPH_RCR   0x104 //-- Receive Counter Register       R/W
#define  PERIPH_TPR   0x108 //-- Transmit Pointer Register      R/W
#define  PERIPH_TCR   0x10C //-- Transmit Counter Register      R/W
#define  PERIPH_RNPR  0x110 //-- Receive Next Pointer Register  R/W
#define  PERIPH_RNCR  0x114 //-- Receive Next Counter Register  R/W
#define  PERIPH_TNPR  0x118 //-- Transmit Next Pointer Register R/W
#define  PERIPH_TNCR  0x11C //-- Transmit Next Counter Register R/W
#define  PERIPH_PTCR  0x120 //-- PDC Transfer Control Register  W
#define  PERIPH_PTSR  0x124 //-- PDC Transfer Status Register   R

#endif


