#include "AT91SAM7X256.h"
#include "LIB_AT91SAM7X256.H"
#include "tn.h"
#include "type.h"
#include "gui_task.h"
#include "lcd_driver.h"
#include "bmpc_132x132_8b.C"
#include "bmp2.C"

#define CLEAR_LCD_CS	AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,AT91C_PIO_PA15);
#define SET_LCD_CS		AT91F_PIO_SetOutput(AT91C_BASE_PIOA,AT91C_PIO_PA15);

U32 WriteSPIByte ( U32 data );
U16 x=0;

void task_gui_func(void * par)
{
AT91PS_SPI pSPI0=AT91C_BASE_SPI0;
AT91PS_PIO pPIO=AT91C_BASE_PIOA;

		pPIO->PIO_ASR = AT91C_PA12_SPI0_NPCS0|AT91C_PA17_SPI0_MOSI|AT91C_PA18_SPI0_SPCK;
		pPIO->PIO_PDR = AT91C_PA12_SPI0_NPCS0|AT91C_PA17_SPI0_MOSI|AT91C_PA18_SPI0_SPCK; // Set in Periph mode

	  	// Configure PMC by enabling SPI clock
  		AT91F_SPI0_CfgPMC();
 		// Reset the SPI (note it is possible to reset the SPI even if SPI is disabled)
		AT91F_SPI_Reset (AT91C_BASE_SPI0);


	    // Configure SPI in Master Mode with No CS selected
	    AT91F_SPI_CfgMode(AT91C_BASE_SPI0, AT91C_SPI_MSTR|AT91C_SPI_MODFDIS|(14<<16));
		pSPI0->SPI_CSR[0] = AT91C_SPI_CPOL|		//SPI Mode 3
							AT91C_SPI_BITS_16|	//SPI_BITS_8
							(2<<8);			//SPCK_Baud_Rate = SPI_Master_Clock_frequency /SCBR	  55/3=18.3
		//Enable the SPI controller
		AT91F_SPI_Enable(AT91C_BASE_SPI0);

GLCD_Initalize();
while(1){
//
GLCD_Clr(&BMP[0]);
tn_task_sleep(500);
GLCD_Clr(&BMP2[0]);
tn_task_sleep(500);
//GLCD_TextGoTo(103,10);
//GLCD_TextStyle(2,0x0);
//GLCD_WriteString("Hello Word");


}
}



